Codeforces 682 C. Alyona and the Tree

49 篇文章 0 订阅
18 篇文章 0 订阅

题目大意

给出一棵 n n n个点的树, 1 1 1为根结点,点有点权,边有边权。
对一棵树来说,如果 ∃ u , v 且 v ∈ s u b t r e e ( u ) \exist u,v 且v\in subtree\pod{u} u,vvsubtree(u)满足 d i s ( u , v ) > a v dis\pod{u,v}>a_v dis(u,v)>av,则这棵树就是不好的。
其中 d i s ( u , v ) dis\pod{u,v} dis(u,v)表示从 u u u v v v路径上的边权和, a v a_v av表示 v v v这个点的权值。

为了使这棵树变好,每次可以删除当前状态下的一个叶子结点,
问至少要删除多少个叶子节点才能使得这棵树变好。

时间限制

1s

数据范围

n ≤ 1 0 5 n\le10^5 n105
所有权值 ≤ 1 0 9 \le 10^9 109

题解

先理解一下题意,考虑一对 ( u , v ) , v ∈ s u b t r e e ( u ) \pod{u,v},v\in subtree\pod{u} (u,v),vsubtree(u),那么对于 v v v来说 u u u是哪一些点?
很显然 u u u就是 v v v到根结点路径上所经过的点。
发现了这一点之后就豁然开朗了。

再理解一下删除叶子节点的含义,也就是说如果要删除一个点,就要把它及其子树都删掉,因为只有把它的子树都删掉以后,它才能成为叶子节点,然后被删去。

于是就可以设状态 f i f_i fi表示从 i i i到根结点路径上的所有的点走到 i i i d i s dis dis最大值, g i g_i gi表示 i i i点及其子树中没有删去的点有多少个。

转移很显然: f i = m a x ( f f a t h e r + 边 权 , 0 ) f_i=max\pod{f_{father}+边权,0} fi=max(ffather+,0)
如果结点 i i i需要被删去,则 g i = 0 g_i=0 gi=0,否则 g i = ∑ j ∈ s o n ( i ) g j g_i=\displaystyle\sum_{j\in son\pod{i}}g_j gi=json(i)gj

Code

//#pragma GCC optimize (2)
//#pragma G++ optimize (2)
#include <cstdio>
#include <algorithm>
#include <cstring>
#include <cmath>
#include <iostream>
#include <vector>
#include <queue>
#define G getchar
#define ll long long
using namespace std;

int read()
{
    char ch;
    for(ch = G();(ch < '0' || ch > '9') && ch != '-';ch = G());
    int n = 0 , w;
    if (ch == '-')
    {
        w = -1;
        ch = G();
    } else w = 1;
    for(;'0' <= ch && ch <= '9';ch = G())n = (n<<1)+(n<<3)+ch-48;
    return n * w;
}

const int N = 100005;
int nxt[N] , lst[N] , to[N] , v[N];
int n , x , y , g[N];
ll f[N];
int ans , si[N];

void dfs(int x)
{
    si[x] = 1;
    for (int i = lst[x] ; i ; i = nxt[i])
    {
        int y = to[i];
        f[y] = max(f[x] + v[i] , (ll)0);
        dfs(y);
        si[x] = si[x] + si[y];
    }
    if (g[x] < f[x])
    {
        ans = ans + si[x];
        si[x] = 0;
    }
}

int main()
{
    //freopen("h.in","r",stdin);
    //freopen("h.out","w",stdout);

    n = read();
    for (int i = 1 ; i <= n ; i ++)
        g[i] = read();

    for (int i = 1 ; i < n; i++)
    {
        x = read();
        nxt[i] = lst[x];
        to[i] = i + 1;
        v[i] = read();
        lst[x] = i;
    }

    ans = 0;
    dfs(1);
    printf("%d\n", ans);

    return 0;
}
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
The problem statement can be found at Codeforces website. Approach: Let's start by looking at some examples: - 1, 2, 3, 4, 5 → No moves needed. - 2, 1, 3, 5, 4 → One move needed: swap index 1 and 2. - 5, 4, 3, 2, 1 → Two moves needed: swap index 1 and 5, then swap index 2 and 4. We can observe that in order to minimize the number of moves, we need to sort the array in non-descending order and keep track of the number of swaps we make. We can use bubble sort to sort the array and count the number of swaps. Let's see how bubble sort works: - Start from the first element, compare it with the second element, and swap them if the second element is smaller. - Move to the second element, compare it with the third element, and swap them if the third element is smaller. - Continue this process until the second-to-last element. At this point, the largest element is in the last position. - Repeat the above process for the remaining elements, but exclude the last position. In each iteration of the above process, we can count the number of swaps made. Therefore, the total number of swaps needed to sort the array can be obtained by summing up the number of swaps made in each iteration. Implementation: We can implement the above approach using a simple bubble sort algorithm. Here's the code: - First, we read the input array and store it in a vector. - We define a variable to keep track of the total number of swaps made and set it to 0. - We run a loop from the first element to the second-to-last element. - In each iteration of the above loop, we run another loop from the first element to the second-to-last element minus the current iteration index. - In each iteration of the inner loop, we compare the current element with the next element and swap them if the next element is smaller. - If a swap is made, we increment the total number of swaps made. - Finally, we output the total number of swaps made. Time Complexity: The time complexity of bubble sort is O(n^2). Therefore, the overall time complexity of the solution is O(n^2). Space Complexity: We are using a vector to store the input array. Therefore, the space complexity of the solution is O(n). Let's see the implementation of the solution.
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值